function adTrailerToFitsHeader, trailer, hdr, interfringecubelow=ifcubelow
COMPILE_OPT IDL2, HIDDEN
  if trailer.nbdim eq -3 then begin
    mkhdr, hdr, 4, [trailer.lx, trailer.ly, trailer.lz]
    sxaddpar, hdr, 'fp_xyz', 1, '0 if fits is in zxy order, 1 if fits is in xyz order'
  endif 
  if trailer.nbdim eq 3 then begin
    mkhdr, hdr, 4, [trailer.lz, trailer.lx, trailer.ly]
    sxaddpar, hdr, 'fp_xyz', 0, '0 if fits is in zxy order, 1 if fits is in xyz order'
  endif
  if trailer.nbdim eq 2 then begin
    mkhdr, hdr, 4, [trailer.lx, trailer.ly]
  endif

  c = 299792.458D

  if abs(trailer.nbdim) eq 3 then begin
    sxaddpar, hdr, 'ctype3', 'VELOCITY'
    sxaddpar, hdr, 'cunit3', 'KM/S'
    if keyword_set(ifcubelow) then sxaddpar, hdr, 'crpix3', 1.0 + abs(trailer.lz) else sxaddpar, hdr, 'crpix3', 1.0d
    sxaddpar, hdr, 'crval3', double((trailer.xl1-trailer.xl0)/trailer.xl0*c+trailer.corrv)
    sxaddpar, hdr, 'cdelt3', double(c/(trailer.lz*trailer.p0))
    sxaddpar, hdr, 'radesys', 'FK5'
    sxaddpar, hdr, 'velref', 3
  endif

  if abs(trailer.nbdim) eq 2 then begin
    sxaddpar, hdr, 'buint', 'KM/S'  ; Doit etre en majuscules!
  endif

  sxaddpar, hdr, 'bscale', 1.0
  sxaddpar, hdr, 'bzero', 0.0

  ; trailer.scale est en arcsec/pixel
  ; bunit est en degre par pixel
;  sxaddpar, hdr, 'bunit', trailer.scale/3600.0

  if (trailer.crval1 ne 0.0) and (trailer.crval2 ne 0.0) and (trailer.crpix1 ne 0.0) and (trailer.crpix2 ne 0.0) then begin
    sxaddpar, hdr, 'ctype1', 'RA---ARC', 'X-axis type'
    sxaddpar, hdr, 'ctype2', 'DEC--ARC', 'Y-axix type'
    sxaddpar, hdr, 'crval1', trailer.crval1, 'Reference pixel value'
    sxaddpar, hdr, 'crval2', trailer.crval2, 'Reference pixel value'
    sxaddpar, hdr, 'crpix1', trailer.crpix1, 'Reference pixel'
    sxaddpar, hdr, 'crpix2', trailer.crpix2, 'Reference pixel'
    sxaddpar, hdr, 'crota2', trailer.crota2, 'Rotation in degrees'
    sxaddpar, hdr, 'cdelt1', trailer.cdelt1, 'Degres/pixel'
    sxaddpar, hdr, 'cdelt2', trailer.cdelt2, 'Degres/pixel'

;    extast, hdr, ast
;    cd = ast.cd

    crota = trailer.crota2/180.0d*!dpi

    cd = [ [cos(crota), -sin(crota)],[sin(crota), cos(crota)] ]
;    cd = [ [-cos(crota),-sin(crota)], [-sin(crota), cos(crota)] ]
    cd[0,*] *= trailer.cdelt1
    cd[1,*] *= trailer.cdelt2

;    cd = (trailer.cdelt1)*[ [-cos(trailer.crota2),-sin(trailer.crota2)], [-sin(trailer.crota2), cos(trailer.crota2)] ]
;    cd[0,0] = cd[0,0]*trailer.cdelt1 & cd[0,1] =  cd[0,1]*trailer.cdelt1
;    cd[1,1] = cd[1,1]*trailer.cdelt2 & cd[1,0] =  cd[1,0]*trailer.cdelt2
;    sxaddpar, hdr, 'cdelt1', trailer.scale/3600.0, 'Degres/pixel'
;    sxaddpar, hdr, 'cdelt2', trailer.scale/3600.0, 'Degres/pixel'
    sxaddpar, hdr, 'equinox', trailer.equinox, 'Equinox of coordinates'
    sxaddpar, hdr, 'cd1_1', cd[0,0]
    sxaddpar, hdr, 'cd1_2', cd[1,0]
    sxaddpar, hdr, 'cd2_1', cd[0,1]
    sxaddpar, hdr, 'cd2_2', cd[1,1]
  endif

  return, hdr
end
