#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "idl_export.h"


#ifdef _WIN32

// Ce floorf ne marchera que sur -4*10^0, 4*10^9... Mais c'est assez
// pour les besoins de ce programme

float my_floorf(float f)
{
  if(f>0.0) {
    return (float)(int)f;
  }
  
  if((f-(float)(int)f) == 0.0) return f;

  return ((float)(int)f)-1.0;

}

float my_ceilf(float f)
{
  if(f<0.0) {
    return (float)(long)f; 
	}

  if((f-(float)(long)f) == 0.0) return f;

  return ((float)(long)f)+1.0;
}

float my_roundf(float f)
{
  float t;
  t = my_floorf(f);

  if(f > 0.0) {
    if((f - t) >= 0.5) {
      return my_ceilf(f);
    }
    return t;
  }
  
  if((f - t) > 0.5) {
    return my_ceilf(f);
  }
  return t;
}

#else

#define my_ceilf(f) ceilf(f)
#define my_roundf(f) roundf(f)

#endif

/* Input parameters:
 * raie ;, threshold, continum, start, stop, raieEff
 */

float my_min(float *arr, int size, int *offset)
{
  float m=arr[0];
  int off=0;
  int i;

  for(i=0; i<size; i++) {
    if(arr[i]<m) {
      m=arr[i];
      off=i;
		}
	}

  if(offset) *offset=off;

  return m;
}

float my_max(float *arr, int size, int *offset)
{
  float m=arr[0];
  int off=0;
  int i;

  for(i=0; i<size; i++) {
    if(arr[i]>m) {
      m=arr[i];
      off=i;
		}
	}

  if(offset) *offset=off;

  return m;
}

void minmax(float *arr, int size, float minmax[2], int offsets[2])
{
  float mi=arr[0];
  float ma=arr[0];
	int mi_off=0;
  int ma_off=0;
	int i;

  for(i=0; i<size; i++) {
    if(arr[i]<mi) {
      mi=arr[i];
			mi_off=i;
		}

    else if(arr[i]>ma) {
			ma=arr[i];
			ma_off=i;
		}
	}

  if(minmax) {
    minmax[0]=mi;
		minmax[1]=ma;
	}

	if(offsets) {
		offsets[0]=mi_off;
		offsets[1]=ma_off;
	}

}

int compare_float(const void *a, const void *b)
{
  return *((float*)a)<*((float*)b)?-1:1;
}


/* C'est lent avec qsort, mais ca marche... */
float median(float *arr, int size)
{
  /* On doit faire une copie de l'array... */
  float val;
#ifdef __GNUC__
  float a[size];
#else
  float *a;
  a = malloc(sizeof(float)*size);
#endif

  memcpy(a, arr, sizeof(float)*size);

  /* Maintenant, on le sort */

  qsort(a, size, sizeof(float), compare_float);

  /* On retourne la valeur du milieu! */

  val = a[size/2];
#ifndef __GNUC__
  free(a);
#endif

  return val;
}


void float_sort(float *arr, int size)
{
  qsort(arr, size, sizeof(float), compare_float);

}


float interpolateX(float x1, float y1, float x2, float y2, float wanted_y)
{
  float m;

	//  printf("InterpolatingX (%f, %f) (%f, %f) to %f\n", x1, y1, x2, y2, wanted_y);

  m = (y2-y1)/(x2-x1);

  wanted_y = wanted_y-y1;

  return wanted_y/m+x1;
}

float mean(float *arr, int size)
{
  int i;
  float m=0.0;

  for(i=0; i<size; i++) m=m+arr[i];

  return m/(float)size;
}

float stddev(float *arr, int size)
{
  float mean=0.0;
  float disp=0.0;
  int i;

  for(i=0; i<size; i++) {
    mean = mean + arr[i];
    disp = disp + arr[i]*arr[i];
	}

  return disp/((float)size) - mean*mean;

}



#define canal_plus(base, off, n) ((base+off)%n)
#define canal_minus(base, off, n) (base-off<0?n+base-off:base-off)

void __baryc(float *raie_d, int n, float pos, float *output_d)
{
  float ma=-1.0;  // max
  int force_ma=0;
  float me;  // mean
	float med; // median
  float hm;  // half maximum
  float fwhm; 
  float flux;
  float fluxpondere;
  float min_val_left;
  float min_val_right;
  float first_noise;
	float continum;
	float dispersion;
  float barypos;
  float baryheight;
	float raie_ch;
  float wraie_ch=0.0;
  int ma_off;
  int left=0, right=0;
  int wleft, wright;
  int minleft, minright;
  int left_by_slope, right_by_slope;
	float last_left, last_right;
  float first_height;
  float max_slope_left, max_slope_right;
  float current_slope_left, current_slope_right;

  int i;
  float j;
  int raie_not_good=0;

  ma = pos;

  if (ma >= 0.0) {
    float max_left, max_right;
    //ma = ma>(float)(n-1)?(float)(n-1):ma;
    ma_off = (int)my_roundf(ma);
    ma_off = ma_off % n;
    ma_off = ma_off<0?ma_off-(n*((ma_off/n)+1)):ma_off;
    ma = raie_d[ma_off];
    force_ma = 1;
    raie_not_good=0;

    /* On trouve un maximum local le plus proche en partant de la position donnee */
    left = right = -1;
    wleft = wright = -1;
    last_left = last_right = ma;
    //max_left = max_right = min(raie_d, n, NULL);
    if((ma > raie_d[canal_minus(ma_off, 1, n)]) && (ma > raie_d[canal_plus(ma_off, 1, n)])) {
      left = ma_off; /* En fait, on ne fait rien! */
		}
		else {
      for(i=1; i<n; i++) {
        int lleft = canal_minus(ma_off, i, n);
        int rright = canal_plus(ma_off, i, n);

  			/* On attend d'avoir une pente montante... */
        if(wleft == -1) wleft = (last_left < raie_d[lleft])?1:-1;
  			if(wright == -1) wright = (last_right < raie_d[rright])?1:-1;

				//        printf("%d: %f %d, %d: %f %d\n", lleft, raie_d[lleft], wleft, rright, raie_d[rright], wright);

        if((wleft != -1) && (last_left > raie_d[lleft])) left = canal_plus(lleft, 1, n);
        if((wright != -1) && (last_right > raie_d[rright])) right = canal_minus(rright, 1, n);

        last_left = raie_d[lleft];
        last_right = raie_d[rright];

  			if((left != -1) || (right != -1)) break;
  		}

			//      printf("%d, %d\n", left, right);

      if((left != -1) && (right != -1)) {
        if((raie_d[left]) > (raie_d[right])) {
  				ma_off = left;
  			}
  			else {
  				ma_off = right;
  			}
  		}
  		else if (!((left == -1) && (right == -1))){
        ma_off = left==-1?right:left;
  		}
		}
		/* Dans le cas ou on n'a rien trouve, on ne touche pas a ma_off... */    
		//    printf("ma_off: %d\n", ma_off);

	}

	/* OK!
	 * On est en business, on peut commencer...
	 */
  if(force_ma == 0) {
#ifdef __GNUC__
    float raie_temp[n];
#else
    float *raie_temp;
    raie_temp = malloc(sizeof(float)*n);
#endif
    memcpy(raie_temp, raie_d, n*sizeof(float));
    raie_not_good=1;
    i=0;
    while(raie_not_good && i<n) {
      /* Premierement, on trouve le canal ou le signal est le plus fort... */
      ma = my_max(raie_temp, n, &ma_off);

    	/* Avant de trouver les bornes de la raie, on regarde si le canal maximum
    	 * peut bien etre une raie.
    	 * Pour ce faire, on s'assure que le flux de part et d'autre du canal
    	 * est superieur a 0.75*flux_moyen, le flux moyen de chanque canal du pixel.
    	 *
    	 * En comptage, ca ne devrait pas arriver. Sur CCD, un rayon cosmique pourrait
    	 * nous donner un mauvais centre...
  		 */
      i++;
      me = mean(raie_temp, n)*0.75;

  		if((me > raie_temp[canal_plus(ma_off, 1, n)]) || (me > raie_temp[canal_minus(ma_off, 1, n)])) {
  			raie_d[ma_off]=me;
  			//			printf("On recommence\n");
  			continue;
  		}

      /* Ici, on a une raie qui fait au moins 3 canaux de large */
  		raie_not_good=0;
      memcpy(raie_d, raie_temp, n*sizeof(float));
  	}
#ifndef __GNUC__
    free(raie_temp);
#endif

    if(raie_not_good) {
      /* Dans le cas ou on n'a pas trouve de max qui a de l'allure, on prend le premier maximum */
      ma = my_max(raie_d, n, &ma_off);
      raie_not_good=0;
		}
	}

  if(!raie_not_good) {
		//	again:
    /* On trouve les bornes de la raie comme etant le premier canal (qui remonte, du
  	 * cote gauche et du cote droit ET qui soit sous la mediane) OU qui soit sous la mediane */
    if(force_ma == 0) {
	    med = median(raie_d, n);
	    first_noise = med - my_min(raie_d, n, NULL);
		}
	  else {
      med = my_max(raie_d, n, NULL); //raie_d[(int)(floor(ma))];
      first_noise = 0.0;
			//      printf("Max: %f\n", med);
		}
		//		printf("Max at: %d, Median: %f\n", ma_off, med);

    ma = my_max(raie_d, n, NULL);

  	left = right = -1;
  	last_left = last_right = ma;
    min_val_left = ma;
    min_val_right = ma;
   	wleft=wright=-1;  // Contiendra la valeur des canaux ou la raie passe sous la median
    minleft=minright=-1;

    for(i=1; i<n; i++) {
      int lleft = canal_minus(ma_off, i, n);
  		int rright = canal_plus(ma_off, i, n);

			//			printf("%d, %d (%2.2f, %2.2f) ", lleft, rright, raie_d[lleft], raie_d[rright]);

      if(left == -1) {
				if((last_left <= raie_d[lleft]) && (wleft != -1)) left = canal_plus(lleft, 1, n);
        //if (((min_val_left + first_noise) <= raie_d[lleft]) && (wleft != -1)) left = canal_plus(lleft, 1, n);
  			else {
  				if((wleft == -1) && (raie_d[lleft] <= med) && (!force_ma || (last_left > (raie_d[lleft] + first_noise)))) wleft=canal_plus(lleft, 1, n);
  				last_left = raie_d[lleft];
  			}
  		}

  		if(right == -1) {
				if((last_right <= raie_d[rright]) && (wright != -1)) right = canal_minus(rright, 1, n);
        //if (((min_val_right + first_noise) <= raie_d[rright]) && (wright != -1)) right = canal_minus(rright, 1, n);
  			else {
  				if((wright == -1) && (raie_d[rright] <= med) && (!force_ma || (last_right > (raie_d[rright] + first_noise)))) wright=canal_minus(rright, 1, n);
  				last_right = raie_d[rright];
  			}
  		}

      if(raie_d[lleft]<min_val_left) {
        min_val_left = raie_d[lleft];
        minleft = lleft;
			}
      if(raie_d[rright]<min_val_right) {
        min_val_right = raie_d[rright];
        minright = rright;
			}
			//      min_val_left = raie_d[lleft]<min_val_left?raie_d[lleft]:min_val_left;
			//      min_val_right = raie_d[rright]<min_val_right?raie_d[rright]:min_val_right;

      if((left != -1) && (right != -1)) break;
  	}

    left = minleft!=-1?minleft:left;
    right = minright!=-1?minright:right;

		//		printf("\n%d, %d, %d, %d\n", left, right, wleft, wright);
  	/* raie_ch contiendra le nombre de canaux qui sont a l'exterieur de la raie */
    if(left > right) raie_ch = (float)(left-right-1);
  	else raie_ch = ((float)(n-right+left-1));
    if(wleft > wright) wraie_ch = (float)(wleft-wright-1);
  	else wraie_ch = ((float)(n-wright+wleft-1));

		//    if (force_ma == 1) {
		//      float raie_temp[n];
		//      int sz;
		//      if(left<right) {
		//        memcpy(raie_temp, &raie_d[left], (right-left+1)*sizeof(float));
		//					sz = right-left+1;
		//			}
		//      else {
		//        memcpy(raie_temp, &raie_d[left], (n-left)*sizeof(float));
		//        memcpy(&raie_temp[n-left], raie_d, right*sizeof(float));
		//        sz = n-left+right+1;
		//			}
		//      max(raie_temp, sz, &ma_off);
		//      ma_off = canal_plus(left, ma_off, n);
		//      force_ma = 0;
		//      goto again;
		//		}

		/* Ici, on traite deux cas speciaux
		 * 1) La raie ne remonte jamais (tres smooth)
		 * 2) La raie fait (presque) tous les canaux
		 * Dans les deux cas, on prend simplement le moment
		 * ou la raie passe sous la mediane
		 */
    if((wleft == 0) && (wright == 0)) {
      /* Signature d'une raie ou tous les canaux sont a la meme valeur.
			 * On fait un test pour verifier...
			 */

			if((raie_d[0] == mean(raie_d, n)) && (raie_d[0] == median(raie_d, n))) {
        raie_not_good = 1;
			}
		}

    if ((left == right) || (left == canal_plus(right, 1, n)) || (raie_ch < (n/5))) {
			//      printf("Ici\n");
      left = wleft;
      right = wright;
		}
		//		printf("Final choice is: %d, %d\n", left, right);
  }
  /* Si left == right, il n'y a pas de raie! */
  if((left == right) || raie_not_good || (wraie_ch < (n/5))) {
		//		printf("Rien trouve\n");
    output_d[0]=0.0;
		output_d[1]=0.0;
    output_d[2]=0.0;
		output_d[3]=0.0;
    output_d[4]=1.0;
		output_d[5]=0.0;
		output_d[6]=0.0;
		output_d[7]=0.0;
		output_d[8]=0.0;

    return;
	}

	//  printf("Ici\n");

  if(force_ma == 0) {

  	/* Ok... maintenant qu'on a les bornes aproximatives de la raie, on trouve
  	 * le continum comme etant la moyenne des canaux qui sont
  	 * a l'exterieur de la raie.
  	 * Es simplo
  	 * On calcule aussi la dispersion (bruit) sur le continum
  	 * en assumant que le continum devrait etre continu (sans blague!)
  	 *
  	 * On pourrait egelement considerer le bruit comme etant un bruit de photon.
  	 * A valider...
  	 */
  	continum=0.0;
  	dispersion=0.0;
  	for(i=canal_plus(right, 1, n); i!=left; i=canal_plus(i, 1, n)) {
  		//		printf("%d ", i);
  		continum = continum + raie_d[i];
  		dispersion = dispersion + raie_d[i]*raie_d[i];
  	} 
  	//	printf("\n");

		//  	printf("Continum: %f, dispersion: %f\n", continum, dispersion);

  	/* raie_ch contiendra le nombre de canaux qui sont a l'exterieur de la raie */
    if(left > right) raie_ch = (float)(left-right-1);
  	else raie_ch = ((float)(n-right+left-1));

  	//	printf("Raie_ch: %f\n", raie_ch);

    continum = continum/raie_ch;
  	//  dispersion = dispersion/raie_ch - continum*continum;
    dispersion = (dispersion - (continum*continum*raie_ch))/(raie_ch-1);
    // On dit dispersion<=0 pour le cas ou la dispersion=0... On a tres peu de chances d'avoir une raie dans ce cas...
    dispersion = dispersion<0.0?0.0:sqrt(dispersion);
  	//  if (dispersion < 0.0) printf("Dispersion: %f\n", dispersion)
  	//  dispersion = dispersion<0.1?0.01:sqrt((float)dispersion);

		//		printf("Continum: %f, dispersion: %f, raie_ch: %f, ma_off: %d\n", continum, dispersion, raie_ch, ma_off);

  	/* Maintenant, pour trouver la vraie raie, on part du centre de la
  	 * raie et on regarde quand le signal tombe sous le niveau du continu,
  	 * a la dispersion du continu pres.
  	 */
  	left = right = -1;
  	last_left = last_right = ma;
    max_slope_left = (raie_d[ma_off]-raie_d[canal_minus(ma_off, 2, n)])/2.0;
		max_slope_right = (raie_d[ma_off]-raie_d[canal_plus(ma_off, 2, n)])/2.0;
    first_height = (raie_d[ma_off]-continum)*0.25;
    left_by_slope=right_by_slope=0;
	
		//		printf("Current continum: %f, current dispersion: %f (%f, %f), first_height: %f\n", continum, dispersion, continum+dispersion, continum+2.0*dispersion, continum+first_height);

  	for(i=1; i<n; i++) {
  	  int lleft = canal_minus(ma_off, i, n);
  		int rright = canal_plus(ma_off, i, n);
	
      current_slope_left = (raie_d[canal_plus(lleft, 1, n)]-raie_d[canal_minus(lleft, 1, n)])/2.0;
      current_slope_right = (raie_d[canal_minus(rright, 1, n)]-raie_d[canal_plus(rright, 1, n)])/2.0;

      max_slope_left = current_slope_left>max_slope_left?current_slope_left:max_slope_left;
      max_slope_right = current_slope_right>max_slope_right?current_slope_right:max_slope_right;

			//      printf("%d, %d    ", lleft, rright);

  	  if(left == -1) {
  			if(raie_d[lleft] <= continum+dispersion) left = canal_plus(lleft, 1, n);
        if(((raie_d[lleft] <= continum+2.0*dispersion) || ((raie_d[lleft]-continum) <= first_height)) && (dispersion > 0.0)) {
          if (current_slope_left <= (max_slope_left/8.0)) {
            left = canal_plus(lleft, 1, n);
            left_by_slope=1;
					}
				}
  		}
	
  		if(right == -1) {
  			if(raie_d[rright] <= continum+dispersion) right = canal_minus(rright, 1, n);
        if(((raie_d[rright] <= continum+2.0*dispersion) || ((raie_d[rright]-continum) <= first_height)) && (dispersion > 0.0)) {
          if (current_slope_right <= (max_slope_right/8.0)) {
						right = canal_minus(rright, 1, n);
						right_by_slope=1;
					}
				}
  	 	}
  	  if((left != -1) && (right != -1)) break;
  	}
		//    printf("Max slope left: %f, right: %f\n", max_slope_left, max_slope_right);
		//    printf("%d, %d\n", left, right);
    /* On verifie pour trouver si left-1 ou right+1 est plus pres du continum... */
		//    printf("%f, %f, %f, %f\n", raie_d[left], continum, raie_d[canal_minus(left, 1, n)], continum);
		//    if(fabs(raie_d[left] - continum) > fabs(raie_d[canal_minus(left, 1, n)] - continum)) {
      if((raie_d[left] >= raie_d[canal_minus(left, 1, n)]) && !left_by_slope)
        left = canal_minus(left, 1, n);
			//		}    
			//    if(fabs(raie_d[right] - continum) > fabs(raie_d[canal_minus(right, 1, n)] - continum)) {
      if((raie_d[right] >= raie_d[canal_plus(right, 1, n)]) && !right_by_slope)
        right = canal_plus(right, 1, n);
			//		}   


  	//	left = right = -1;
		//	last_left = last_right = ma;
		//
		//	wleft=wright=0;
		//	for(i=1; i<n; i++) {
		//		int lleft = canal_minus(ma_off, i, n);
		//		int rright = canal_plus(ma_off, i, n);
		//
		//		if(left == -1) {
		//			if(((last_left+dispersion) <= raie_d[lleft]) || wleft) left = canal_plus(lleft, 1, n);
		//			else {
		//				if(!wleft && (raie_d[lleft] < (continum+dispersion))) wleft=1;
		//				last_left = raie_d[lleft];
		//			}
		//		}
		//
		//		if(right == -1) {
		//			if(((last_right+dispersion) <= raie_d[rright]) || wright) right = canal_minus(rright, 1, n);
		//			else {
		//				if(!wright && (raie_d[rright] < (continum+dispersion))) wright=1;
		//				last_right = raie_d[rright];
		//			}
		//		}
		//
		//		if((left != -1) && (right != -1)) break;
		//	}


		//		printf("\n%d, %d\n", left, right);

		/* On recalcule le continum et la dispersion... 
		 * en tenant compte de la vraie raie...
		 */
		continum=0.0;
		dispersion=0.0;
		for(i=canal_plus(right, 1, n); i!=left; i=canal_plus(i, 1, n)) {
			//		printf("%d(%f) ", i, raie_d[i]);
			continum = continum + raie_d[i];
			dispersion = dispersion + raie_d[i]*raie_d[i];
		} 
		//	printf("\n");

		/* raie_ch contiendra le nombre de canaux qui sont a l'exterieur de la raie */
		if(left > right) raie_ch = (float)(left-right-1);
		else raie_ch = ((float)(n-right+left-1));

		//	printf("Continum: %f, dispersion: %f, raie_ch: %f\n", continum, dispersion, raie_ch);

		continum = continum/raie_ch;
		dispersion = dispersion/raie_ch - continum*continum;
		//  dispersion = dispersion>0.0?sqrt((double)dispersion):0.0;
		//	printf("Continum: %f, dispersion: %f, raie_ch: %f\n", continum, dispersion, raie_ch);
	}
  else {
		/* Dans le cas ou on demandait de rechercher la raie
		 * autour d'un certain canal, le continu est la moyenne
		 * des permier canaux de la raie et la dispersion est
		 * la dispersion sur ces deux canaux
		 */
    continum = (raie_d[left] + raie_d[right])/2.0;
    dispersion = raie_d[left]*raie_d[left] + raie_d[right]*raie_d[right];
		dispersion = dispersion/2.0 - continum*continum;
	}

	/* Maintenant qu'on connait la vraie raie et le vrai continum,
	 * on calcule le flux et le flux pondere de la raie
	 * pour trouver le barycentre...
	 */
	flux=0.0;
	fluxpondere=0.0;
	j=(float)left;
	for(i=left; i!=canal_plus(right, 1, n); i=canal_plus(i, 1, n)) {
		//		printf("%d(%f) ", i, raie_d[i]);
    flux = flux + fabs(raie_d[i] - continum);
		fluxpondere = fluxpondere + fabs(raie_d[i] - continum)*j;
    j = j+1.0;
	}
	//	printf("\n");

	/* raie_ch contiendra la largeur de la raie a la base */
  if(left > right) raie_ch = (float)(n-left+right+1);
	else raie_ch = (float)(right-left+1);

	/* On trouve le barycentre de la raie */
  barypos = fluxpondere/flux;
  if(((int)my_ceilf(barypos)) > n) barypos = barypos - (float)n;
  if(barypos < 0.0) barypos = barypos + (float)n;
	baryheight = flux/((float)(raie_ch-1));

	//  else {
	//    barypos = (float)ma_off;
	//    baryheight = ma - continum;
	//	}
	//	printf("flux: %f, flux pondere: %f\n", flux, fluxpondere);
	//  printf("left: %d, right: %d\n", left, right, j);
	//	printf("barypos: %f, baryheight: %f, raie_ch: %f\n", barypos, baryheight, raie_ch);

	/* On trouve la largeur a mi-hauteur */
	hm = baryheight+continum;

	//	printf("On part de left: %d, right: %d\n", left, right);
  wleft = -1;
	wright = -1;
  for(i=0; i<n; i++) {
    int lleft = canal_plus(left, i, n);
		int rright = canal_minus(right, i, n);

		//		printf("%d (%d:%f, %d:%f)\n", i, lleft, raie_d[lleft], rright, raie_d[rright]);
    if(wleft == -1) {
      if(raie_d[lleft] > hm) wleft = canal_minus(lleft, 1, n);
		}

		if(wright == -1) {
      if(raie_d[rright] > hm) wright = canal_plus(rright, 1, n);
		}

    if((wleft != -1) && (wright != -1)) break;
	}

	/* maintenant, on interpole pour trouver la vraie largeur a la hauteur de hm */
	//	printf("wleft: %d, wright: %d\n", wleft, wright);
	//	printf("Left interpolation:  %f\n", interpolateX(wleft, raie_d[wleft], canal_plus(wleft, 1, n), raie_d[canal_plus(wleft, 1, n)], hm));
	//	printf("Right interpolation: %f\n", interpolateX(canal_minus(wright, 1, n), raie_d[canal_minus(wright, 1, n)], wright, raie_d[wright], hm));
  if(wright < wleft) {
    fwhm = (float)n - interpolateX((float)wleft, raie_d[wleft], (float)(wleft+1), raie_d[canal_plus(wleft, 1, n)], hm) + interpolateX((float)(wright-1), raie_d[canal_minus(wright, 1, n)], (float)wright, raie_d[wright], hm);
	}
	else {
    fwhm = interpolateX((float)(wright-1), raie_d[canal_minus(wright, 1, n)], wright, raie_d[wright], hm) - interpolateX(wleft, raie_d[wleft], (float)(wleft+1), raie_d[canal_plus(wleft, 1, n)], hm);
	}

  flux=flux<0.0?0.0:flux;
  //continum=continum<1.0?1.0:continum;
	//  dispersion = dispersion<1.0?1.0:dispersion;
  dispersion = dispersion<0.0?1000.0:sqrt((float)dispersion);

  output_d[0]=barypos;
  output_d[1]=baryheight;
  output_d[2]=flux;
  output_d[3]=continum;
  output_d[4]=dispersion;
  output_d[5]=fwhm;
	output_d[6]=hm;
	output_d[7]=(float)left;
	output_d[8]=(float)right;
}

IDL_VPTR baryc(int argc, IDL_VPTR argv[])
{
  IDL_VPTR raie, output;
	float *raie_d, *output_d;
  float pos=-1.0;
  IDL_MEMINT dim[IDL_MAX_ARRAY_DIM];
  IDL_MEMINT n;

  raie = argv[0];

	IDL_ENSURE_SIMPLE(raie);
  IDL_ENSURE_ARRAY(raie);

	n = raie->value.arr->dim[0];
	raie_d = (float*)raie->value.arr->data;

  /* On permet de demander de reperer une raie
	 * autour d'un certain canal...
	 */
  if(argc > 1) {
    IDL_VPTR maximum = argv[1];
    IDL_ENSURE_SIMPLE(maximum);
    IDL_ENSURE_SCALAR(maximum);
		pos = maximum->value.f;
	}

  /* Nous retournerons:
   * 0: position du barycentre
	 * 1: hauteur du barycentre
	 * 2: flux monochromatique
   * 3: continum
	 * 4: dispersion du continum (exterieur de la raie)
   * 5: fwhm
	 * 6: hm
	 * 7: start // Utilise pour deboggage seuelement
	 * 8: stop  // Utilise pour deboggage seuelement
   */
  dim[0]=9;
  output_d = (float*)IDL_MakeTempArray(IDL_TYP_FLOAT, 1, dim, IDL_ARR_INI_NOP, &output);

  __baryc(raie_d, n, pos, output_d);

  return output;
}


int IDL_Load(void)
{
  static IDL_SYSFUN_DEF2 function_addr[] = {
		{{baryc}, "BARYC", 1, 2, 0, 0 },
	};

	return IDL_SysRtnAdd(function_addr, TRUE, IDL_CARRAY_ELTS(function_addr));
}
