function coAddLambda, lambda1, lambda2, rotate=rot, expand=expand, alignzone1=a1, alignzone2=a2, noz=noz

  if n_elements(rot) eq 0 then rot = 0
  if n_elements(expand) eq 0 then expand = 0

  if (n_elements(a1) ne 0) and (n_elements(a2) ne 0) and (n_elements(a1) eq n_elements(a2)) then begin
    ; On doit obtenir deux zones de meme grandeur...
    xcen1 = round(mean([a1.x1, a1.x2]))
    ycen1 = round(mean([a1.y1, a1.y2]))
    xcen2 = round(mean([a2.x1, a2.x2]))
    ycen2 = round(mean([a2.y1, a2.y2]))

    xwidth = round(mean([abs(a1.x1-a1.x2), abs(a2.x1-a2.x2)]))>22
    ywidth = round(mean([abs(a1.y1-a1.y2), abs(a2.y1-a2.y2)]))>22

    reg1 = {sky_zone}
    reg1.x1 = round(xcen1-xwidth/2)
    reg1.x2 = round(xcen1+xwidth/2)
    reg1.y1 = round(ycen1-ywidth/2)
    reg1.y2 = round(ycen1+ywidth/2)

    reg2 = {sky_zone}
    reg2.x1 = round(xcen2-xwidth/2)
    reg2.x2 = round(xcen2+xwidth/2)
    reg2.y1 = round(ycen2-ywidth/2)
    reg2.y2 = round(ycen2+ywidth/2)
  endif

  if (total(size(lambda1) eq size(lambda2)) ne total(size(lambda1) eq size(lambda1))) and (expand eq 0) then begin
    sz = size(lambda1)
    lambda2 = congrid(lambda2, sz[1], sz[2], sz[3])
  endif

  sz = size(lambda1)
  zsize = sz[1]
  xsize = sz[2]
  ysize = sz[3]

  if rot ne 0 then begin
    for j=0, zsize-1 do begin
      lambda2[j,*,*] = rotate(lambda2[j,*,*], rot)
    endfor
  endif

  if n_elements(reg1) eq 0 then begin
    reg1 = {sky_zone}
    reg1.x1 = xsize/4
    reg1.x2 = 3*xsize/4-1
    reg1.y1 = ysize/4
    reg1.y2 = 3*ysize/4-1

    xcen1 = round(mean([reg1.x1, reg1.x2]))
    ycen1 = round(mean([reg1.y1, reg1.y2]))
  endif

  if n_elements(reg2) eq 0 then begin
    reg2 = {sky_zone}
    reg2.x1 = xsize/4
    reg2.x2 = 3*xsize/4-1
    reg2.y1 = ysize/4
    reg2.y2 = 3*ysize/4-1

    xcen2 = round(mean([reg2.x1, reg2.x2]))
    ycen2 = round(mean([reg2.y1, reg2.y2]))
  endif

  xsize = abs(reg1.x2-reg1.x1)
  ysize = abs(reg1.y2-reg1.y1)
 
  tot1 = (total(lambda1, 1))[reg1[0].x1:reg1[0].x2-1, reg1[0].y1:reg1[0].y2-1] ;xsize/4:3*xsize/4-1, ysize/4:3*ysize/4-1]
  tot2 = (total(lambda2, 1))[reg2[0].x1:reg2[0].x2-1, reg2[0].y1:reg2[0].y2-1] ;xsize/4:3*xsize/4-1, ysize/4:3*ysize/4-1]

  tot1 = rescale(tot1, 0.95, 0.99)
  tot2 = rescale(tot2, 0.95, 0.99)

;  if (xsize lt 30) or (ysize lt 30) then begin
;    t1 = fltarr(xsize lt 30?30:xsize, ysize lt 30?30:ysize)
;    t2 = t1
;    t1 += min(tot1)
;    t2 += min(tot2)
;    t1[0:xsize-1,0:ysize-1] = tot1
;    t2[0:xsize-1,0:ysize-1] = tot2
;    tot1 = t1
;    tot2 = t2
;  endif

  window, 0, xsize=512, ysize=512.0*float(ysize)/xsize
  tvscl, congrid(tot1, 512, 512.0*float(ysize)/xsize)
  window, 1, xsize=512, ysize=512.0*float(ysize)/xsize
  tvscl, congrid(tot2, 512, 512.0*float(ysize)/xsize)

  crunchx1 = total(tot1, 2)
  crunchx2 = total(tot2, 2)
  crunchy1 = total(tot1, 1)
  crunchy2 = total(tot2, 1)

  crunchz1 = total(total(lambda1[*,reg1[0].x1:reg1[0].x2, reg1[0].y1:reg1[0].y2], 2), 2)
  crunchz2 = total(total(lambda2[*,reg2[0].x1:reg2[0].x2, reg2[0].y1:reg2[0].y2], 2), 2)

  crunchz1 = [crunchz1, crunchz1, crunchz1]
  crunchz2 = [crunchz2, crunchz2, crunchz2]

  lagx = findgen(xsize)-(xsize/2)
  lagy = findgen(ysize)-(ysize/2)
  lagz = findgen(zsize*3)-((zsize*3)/2)
  
  cc = c_correlate(crunchx1, crunchx2, lagx)
  max = max(cc, idx)
  idx = (idx < (xsize-11)) > 10
  fit = poly_fit(lagx[idx-10:idx+10], cc[idx-10:idx+10], 2)
  dx = -0.5*fit[1]/fit[2]
  dx = dx + (reg2[0].x1 - reg1[0].x1)

  cc = c_correlate(crunchy1, crunchy2, lagy)
  max = max(cc, idx)
  idx = (idx < (ysize-11)) > 10
  fit = poly_fit(lagy[idx-10:idx+10], cc[idx-10:idx+10], 2)
  dy = -0.5*fit[1]/fit[2]
  dy = dy + (reg2[0].y1 - reg1[0].y1)

  cc = c_correlate(crunchz1, crunchz2, lagz)
  max = max(cc, idx)
  idx = (idx < (zsize*3-11)) > 10
  fit = poly_fit(lagz[idx-10:idx+10], cc[idx-10:idx+10], 2)
  dz = -0.5*fit[1]/fit[2]
  dz = dz mod zsize

  if keyword_set(noz) eq 0 then begin

    print, dx, dy, dz

    for i=0, xsize-1 do begin
      for j=0, ysize-1 do begin
        rt = lambda2[*,i,j]
        lambda2[*,i,j] = (interpolate([rt, rt, rt], findgen(zsize*3)+dz))[zsize:zsize*2-1]
      endfor
    endfor

  endif else print, dx, dy

  if expand eq 0 then begin
    for j=0, zsize-1 do begin
      lambda1[j,*,*] = lambda1[j,*,*] + interpolate(lambda2[j,*,*], findgen(sz[2])+dx, findgen(sz[3])+dy, /grid, cubic=-0.6)
    endfor
    return, lambda1
  endif else begin
    szl2 = size(lambda2)

    growx = ceil(abs(sz[2]-szl2[2])-(xcen1-xcen2)-dx)
    growy = ceil(abs(sz[3]-szl2[3])-(ycen1-ycen2)-dy)
    lambda = fltarr(sz[1], sz[2]+growx, sz[3]+growy)
    newsz = size(lambda)
 
    print, size(lambda)

    error

    firstxpos = round(dx lt 0?0:dx)
    firstypos = round(dy lt 0?0:dy)
    secondxpos = round(dx lt 0?abs(dx):0)
    secondypos = round(dy lt 0?abs(dy):0)

    if n_elements(a1) ne 0 then begin
      a1.x1 += firstxpos
      a1.x2 += firstxpos
      a1.y1 += firstypos
      a1.y2 += firstypos
    endif

    lambda[*, secondxpos:secondxpos+szl2[2]-1, secondypos:secondypos+szl2[3]-1] = lambda2

    tinydx = dx - round(dx)
    tinydy = dy - round(dy)
    for j=0, zsize-1 do begin
      lambda[j,*,*] = interpolate(lambda[j,*,*], findgen(newsz[2])+tinydx, findgen(newsz[3])+tinydy, /grid, cubic=-0.6)
    endfor
    lambda[*, firstxpos:firstxpos+sz[2]-1, firstypos:firstypos+sz[3]-1] += lambda1
    return, lambda
  endelse

end
