function computeCalibrationFinesse, calib, prb, cen, plot=p, validcalib=validcalib
  if n_elements(p) eq 0 then p=0

  lambda = createLambda(calib, prb)

  sz = size(calib)

  if n_elements(validcalib) ne 0 then begin
    small = lambda[*, validcalib]
    small = total(small,2)
  endif else begin
    small = lambda[*, cen[0]-sz[2]/4:cen[0]+sz[2]/4, cen[1]-sz[3]/4:cen[1]+sz[3]/4]
    small = total(total(small, 2), 2)
  endelse

  b = baryc(small)

  fit = gaussfit(findgen(sz[1]), small, a, nterms=4, sigma=sigma)
  fwhm = 2*sqrt(2*alog(2))*a[2]

;  print, sz[1]/b[5]
;  print, sz[1]/fwhm


  if p eq 1 then begin
    sn = computeSignalNoiseValue(small, signal, noise, flux, continum, b, start, stop, raiet, dispersion)
;    print, sn

;    print, signal, noise, sn, start, stop, x, y
    loadct, 13
    plot, small, xtitle='Canaux', ytitle='Photons', yrange=[min(small), max(small)+2], xrange=[0, sz[1]-0.5], psym=10, xstyle=1
    xyouts, 100, 450, 'S/N: ' + strtrim(sn,2), /device
;    xyouts,5, max(cube[*,x,y])-(max(cube[*,x,y])/10)>1, 'S/Nd: ' + strtrim(signal/noise,2)
;    xyouts,5, max(cube[*,x,y])-(max(cube[*,x,y])/20)>0.5, 'Disp: ' + strtrim(output[4],2)
    oplot, findgen(sz[1]), replicate(continum+dispersion, sz[1]), linestyle=1
    oplot, findgen(sz[1]), replicate(continum-dispersion, sz[1]), linestyle=1
    oplot, findgen(sz[1]), replicate(continum, sz[1])
;    oplot, findgen(sz[1]), replicate(output[9]+output[2], sz[1])
    oplot, [b[0]], [b[1]+continum], psym=1
;    oplot, [b[0]], [b[1]+continum], psym=1, color=120
    oplot, replicate(start, 2), [0,max(small)], linestyle=1
    oplot, replicate(stop, 2), [0,max(small)], linestyle=1

    fit = gaussfit(findgen(sz[1]), small, a, nterms=4, sigma=sigma)
;    print, 'Resultats du fit ', a
;    print, '  fwhm: ', 2*sqrt(2*alog(2))*a[2]
    oplot, findgen(sz[1]), fit, color=120
  
    output = baryc(small)
    fit = makeGaussian([2*output[1], output[0], output[5]/(2*sqrt(2*alog(2))), output[3]], findgen(sz[1]*10)/10.0)
    oplot, findgen(sz[1]*10)/10.0, fit
  endif else begin
    output = baryc(small)
  endelse

  b = output

  return, sz[1]/b[5]

end
