; mono/dispersion+sqrt(mono+continum)


; ********************
; Compute signal noise value
; ********************
; Cette fonction recoit une raie en parametre et retourne la valeur du
; rapport signal/bruit de la raie
function computeSignalNoiseValue, raie, signal, noise, flux, continum, b, start, stop, raiet, dispersion, fwhm
  a = baryc(raie)
  flux = a[2]
  signal = a[2] ; Ancienne methode: a[1]+a[3]
  noise = sqrt(a[2] + a[4]*a[4]) ;sqrt(a[2]) + a[4]; Ancienne methode: a[4] 
  continum = a[3]
  b = [a[0], a[1]]
  start = a[7]
  stop = a[8]
  dispersion = a[4]
  fwhm = a[5]
  raiet = (raie > continum) - continum
  return, signal/noise ; (dispersion^2) ; noise
end

function computeSignalNoiseValueOld, raie, signal, noise, flux, continum, b, start, stop, raiet, dispersion
  threshold = (n_elements(threshold) eq 0)?0.5:threshold

  b = bary(raie, threshold, continum, start, stop, raiet)

  signal = (start gt stop)?total(raiet[0:stop]) + total(raiet[start:n_elements(raiet)-1]) : total(raiet[start:stop])
  flux = signal
  noise = (signal eq 0)?1:sqrt(signal)+sqrt(continum>0)

  dispersion=0

  return, signal/noise
end

;function computeSignalNoiseValue, raie, signal, noise, width, continum, bary
;COMPILE_OPT IDL2
;  continum = continum(raie, 0.5)
;  raie80 = (raie > continum) - continum

;  bary = bary(raie80)

;  candidates = where(raie80 gt 0)
;  if (n_elements(candidates) eq 1) and (candidates[0] eq -1) then begin
;    start=0
;    stop=0
;    goto, fin
;  endif

;  goodidx = where(candidates eq floor(bary[0]))

;  if (n_elements(goodidx) eq 1) and (goodidx[0] eq -1) then begin
;    tempo = min(abs(candidates-floor(bary[0])), goodidx)
;  endif

;  goodidx = candidates[goodidx]

;  good = candidates - shift(candidates, 1)

;  test = where(good ne 1)
;  if (n_elements(test) eq 1) and (test[0] eq -1) then begin
;    start = goodidx[0]
;  endif else begin
;    start = candidates[test]
;    start = start < (goodidx[0]+1)
;    test = where(start ne (goodidx[0]+1))
;    if (n_elements(test) eq 1) and (test[0] eq -1) then begin
;      start = goodidx
;    endif else begin
;      start = max(start[test])
;    endelse
;  endelse

;  good = shift(candidates - shift(candidates, 1), -1)
;  good = good[0:n_elements(good)-2]

;  test = where(good ne 1)
;  if (n_elements(test) eq 1) and (test[0] eq -1) then begin
;    stop = goodidx[0]
;  endif else begin
;    stop = candidates[test]
;    stop = stop > (goodidx[0]-1)
;    test = where(stop ne (goodidx[0]-1))
;    if (n_elements(test) eq 1) and (test[0] eq -1) then begin
;     stop = goodidx
;    endif else begin
;      stop = min(stop[test])
;    endelse

;  endelse

;;  i = 0 
;;  while 1 do begin
;;    idx = goodidx-i
;;    if idx lt 0 then break
;;
;;    if good[idx] ne 1 then begin
;;      good[idx] = 1
;;      if idx ge 1 then good[0:idx-1] = 0
;;      break
;;    endif
;;
;;    i = i+1
;;  endwhile
;;
;;  sz = n_elements(good)
;;
;;  i = 0
;;  while 1 do begin
;;    idx = goodidx+i
;;    if idx ge sz then break
;;
;;    if good[idx] ne 1 then begin
;;      good[idx] = 1
;;      if idx le sz-2 then good[idx+1:sz-1] = 0
;;      break
;;    endif
;;
;;    i = i+1
;;  endwhile

;;  print, candidates[where(good eq 1)]

;;  signal = total(raie80[candidates[where(good eq 1)]])
;fin:
;  signal = total(raie80[start:stop])
;  if signal eq 0 then begin
;    signal=0
;    noise=1
;  endif else begin
;    noise = sqrt(signal)
;  endelse

;fin_fin:
;  width = stop-start+1

;  return, signal/noise

;end


; ********************
; Compute signal noise value
; ********************
; Cette fonction recoit une raie en parametre et retourne la valeur du
; rapport signal/bruit de la raie
function computeSignalNoiseValueByGaussianFitting, raie, signal, noise
COMPILE_OPT IDL2
  continum = continum(raie, 0.8)
  raie80 = (raie > continum) - continum

  n = n_elements(raie)
  fit = gaussfit(findgen(n), raie80, a, nterms=4, sigma=sigma)
  ; Si on ne reussit pas a faire de fit,
  ; c'est peut-etre parce qu'on a un saut d'interfrange...
  ; et qu'il est vraiment centre sur le debut/fin de la raie
  if (a[1] ge 2*n) or (a[1] lt -n+1) then begin
    usedRaie = fltarr(n)
    usedRaie[0:n/2-1] = raie[n/2:n-1]
    usedRaie[n/2:n-1] = raie[0:n/2-1]
  
    raie80 = (usedRaie > continum) - continum
    fit = gaussfit(findgen(n), raie80, a, nterms=4, sigma=sigma, yerror=yerror)

    ; Si le fit est toujours impossible: c'est qu'il n'y a pas de raie!
    ;if (a[1] ge 3*n) or (a[1] lt -2*n+1) then begin
    ;  error
    ;endif
  endif

  fwhm = abs(2*sqrt(2*alog(2))*a[2])

  raiemin = floor(a[1]-fwhm)
  raiemax = ceil(a[1]+fwhm)

  if raiemin lt 0 then begin
    raietemp = raie80
    sr = size(raie80)
    raie80 = fltarr(sr[1]*2)
    raie80[0:sr[1]-1] = raietemp
    raie80[sr[1]:sr[1]*2-1] = raietemp
    raiemin = raiemin + sr[1]
    raiemax = raiemax + sr[1]
  endif

  sr = size(raie80)

  if raiemax gt sr[1]-1 then begin
    raietemp = raie80
    raie80 = fltarr(sr[1]*2)
    raie80[0:sr[1]-1] = raietemp
    raie80[sr[1]:sr[1]*2-1] = raietemp
  endif

  if (raiemin lt 0) or (raiemax gt (size(raie80))[1]-1) then begin
    signal = 0
    noise = 1
  endif else begin
    signal = total(raie80[raiemin:raiemax])
    noise = sqrt(signal)
  endelse

;  plot, raie80
;  oplot, fit, psym = 1

;  print, raiemin, raiemax
;  print, signal, noise, signal/noise

  return, signal/noise
end


