pro createCalibrationFiles, bru, prb, sum, rvcal, validCalid, ad3=ad3file, adp=adpfile, usebrute=usebrute
  if n_elements(adpfile) eq 0 then begin
    adp = findfile('*.adp')
    if n_elements(ada) eq 1 then begin
      adp = findfile('*.ADP')
    endif

    if strcmp(adp[0], '') eq 1 then begin
     print, 'No adp file found...'
       return
    endif
  endif else begin
    adp= adpFile
  endelse

  if n_elements(ad3file) eq 0 then begin
    ad3file = findfile('calibration.ad3*')
    if (file_test(ad3file[0], /read) eq 0) or (ad3file[0] eq '') then begin
      print, 'No calibration file found...'
      return
    endif
    ad3 = 'calibration.ad3'
  endif else begin
    ad3 = ad3file
  endelse

  adp = adp[0]
  print, 'Using file ' + adp

  trailer = adpToAd3Trailer(adp, calibwl)
  calibration = readad3(ad3)

  calibrate, calibration, trailer, calibwl, bru, prb, sum, rvcal, finesse, validCalib, center=cen, usebrute=usebrute

  toto = writead2('cal_bru.ad2', bru)
  toto = writead2('cal_prb.ad2', prb)
  toto = writead2('cal_sum.ad2', sum) 
  toto = writead2('cal_rv.ad2', rvcal)
  toto = writead1('cal_cen.ad1', cen)
  writefits, 'cal_valid.fits', validCalib

;  print, 'Computing calibration finesse...'
;  finesse = computecalibrationfinesse(calibration, prb, cen, plot=p)
  toto = writead1('cal_finesse.ad1', finesse)
end
