function fitsHeaderToAdTrailer, hdr, trailer
COMPILE_OPT IDL2, HIDDEN
  
  if n_elements(trailer) eq 0 then return, -1

  trailer.nbdim = sxpar(hdr, 'naxis')

  if trailer.nbdim eq 3 then begin
    xyz = sxpar(hdr, 'fp_xyz', count=i)
  
    if i ne 0 then begin
      if xyz eq 0 then begin
        trailer.lx = sxpar(hdr, 'naxis2')
        trailer.ly = sxpar(hdr, 'naxis3')
        trailer.lz = sxpar(hdr, 'naxis1')
      endif else begin
        trailer.lx = sxpar(hdr, 'naxis1')
        trailer.ly = sxpar(hdr, 'naxis2')
        trailer.lz = sxpar(hdr, 'naxis3')
        trailer.nbdim = -trailer.nbdim
      endelse
    endif else begin
      ; Ok... si on est ici, c'est que le
      ; parametre fp_xyz n'est pas dans le header...
      ; On va assumer que la plus petite dimension est z...
      
      min = min([sxpar(hdr, 'naxis1'), sxpar(hdr, 'naxis2'), sxpar(hdr, 'naxis3')], idx)
      if idx eq 0 then begin
        trailer.lx = sxpar(hdr, 'naxis2')
        trailer.ly = sxpar(hdr, 'naxis3')
        trailer.lz = sxpar(hdr, 'naxis1')
      endif else begin
        trailer.lx = sxpar(hdr, 'naxis1')
        trailer.ly = sxpar(hdr, 'naxis2')
        trailer.lz = sxpar(hdr, 'naxis3')
        trailer.nbdim = -trailer.nbdim
      endelse
    endelse
  endif else begin
    trailer.lx = sxpar(hdr, 'naxis1')
    trailer.ly = sxpar(hdr, 'naxis2')
    trailer.lz = 1
  endelse

  trailer.scale = sxpar(hdr, 'cdelt1')*3600.0

  trailer.crval1 = sxpar(hdr, 'crval1')
  trailer.crval2 = sxpar(hdr, 'crval2')
  trailer.crpix1 = sxpar(hdr, 'crpix1')
  trailer.crpix2 = sxpar(hdr, 'crpix2')
  trailer.cdelt1 = sxpar(hdr, 'cdelt1')
  trailer.cdelt2 = sxpar(hdr, 'cdelt2')
  trailer.crota2 = sxpar(hdr, 'crota2')
  trailer.equinox = sxpar(hdr, 'equinox')

  if (trailer.cdelt1 eq 0) or (trailer.cdelt2 eq 0) then begin
    getrot, hdr, rot, cdelt

    trailer.cdelt1 = -cdelt[0]
    trailer.cdelt2 = cdelt[1]
    trailer.crota2 = rot
  endif


  if trailer.equinox eq 0 then trailer.equinox=2000.0

  return, trailer
end
