pro fitsmedian, files, output, maxmem, display=d, silent=sil

  if n_elements(maxmem) eq 0 then maxmem = 64

  ; maxmem est en megs.
  maxmem = float(maxmem)*float(1024)*float(1024)

  im = readfits(files[0], hdr)

  imtype = size(im)
  imtype = imtype[imtype[0]+1]

  sz = size(im)

  ; On ne supporte que le 2d pour l'instant...

  totalsize = float(sz[1]*sz[2]*n_elements(files))
  factor = ceil(totalsize / maxmem)

  print, 'Doing it in ' + strtrim(long(factor),2) + ' pass' + ((factor gt 1)?'es':'')
;  print, 'Imtype is ' + strtrim(imtype,2)

  xsize = float(sz[1])
  ysize = float(sz[2])

  med = make_array(xsize, ysize, type=imtype)

  if keyword_set(d) then window, 0, xsize=xsize/4, ysize=ysize/4

  for i=0.0, factor-1 do begin
;    xbegin = floor(i/factor*xsize)
;    xend = (1.0+i)/factor*xsize
    xbegin = 0
    xend = xsize
    ybegin = floor(i/factor*ysize)
    yend = (1.0+i)/factor*ysize

    print, 'Pass ' + strtrim(long(i),2) + ' (' + strtrim(long(xbegin),2) + ':' + strtrim(long(xend),2) + ', ' + strtrim(long(ybegin),2) + ':' + strtrim(long(yend),2) + ')'

    meds = make_array(n_elements(files), xend-xbegin, yend-ybegin, type=imtype, /nozero)

    for k=0, n_elements(files)-1 do begin
      if keyword_set(sil) eq 0 then print, 'Reading ' + files[k]
;      meds[k,*,*] = (readfits(files[k], /silent))[xbegin:xend-1, ybegin:yend-1]
      fxread, files[k], im, h, xbegin, xend-1, ybegin, yend-1
      meds[k,*,*] = im
    endfor

    med[xbegin:xend-1,ybegin:yend-1] = mymedarr(meds)

;    med[xbegin:xend-1,ybegin:yend-1] = median(meds, dimension=1)

    if keyword_set(d) then tvscl, congrid(med, xsize/4, ysize/4)

  endfor

  if n_elements(output) eq 0 then begin
    name = strsplit(files[0], '.', /extract)
    name = name[n_elements(name)-2]

    output=name + '-median.fits'
  endif

  writefits, output, med, hdr

end
