function fitsToAd2, fits, ad2
  if n_params() eq 0 then begin
    print, 'Syntax: fitsToAd2(fits, ad2, trailer, fits_xyz=fx)'
    print, '   fits - fits file to read from'
    print, '    ad2 - ad2 file to write to'
    print, 'trailer - ad2 trailer to start from '
    return, -1
  endif

  if n_elements(ad2) eq 0 then begin
    ad2 = strarr(n_elements(fits))
    for i=0, n_elements(fits)-1 do begin
      test = strsplit(fits[i], '.')
      ad2[i] = string((byte(fits[i]))[0:test[n_elements(test)-1]-2]) + '.ad2'
    endfor
  endif

  final = 0

  for i=0, n_elements(fits)-1 do begin

    im = float(readfits(fits[i], hdr, /silent))

    idx = where(im le !values.f_infinity, complement=idx_nan)
    if idx_nan[0] ne -1 then im[idx_nan] = -3.1E+38

    if (n_elements(im) eq 1) and (im[0] eq -1) then begin
      final += 1
      continue
    endif
 
    if n_elements(trailer) eq 0 then trailer = {ad2_trailer}

    trailer = fitsHeaderToAd2Trailer(hdr, trailer)

    final += writeAd2(ad2[i], im, trailer)
  endfor

  return, final

end

