function fitsToAd3, fits, ad3, trailer, ad3_xyz=ax
COMPILE_OPT IDL2
  if n_params() eq 0 then begin
    print, 'Syntax: fitsToAd3(fits, ad3, trailer, fits_xyz=fx)'
    print, '   fits - fits file to read from'
    print, '    ad3 - ad2 file to write to'
    print, 'trailer - ad3 trailer to start from'
    print, 'ad3_xyz - 0: Write ad3 in zxy format'
    print, '          1: Write ad3 in xyz format'
    print, '           Default: 0'
    return, -1
  endif

  im = readfits(fits, hdr, /silent)

  if (n_elements(im) eq 1) and (im[0] eq -1) then return, -1

  if n_elements(trailer) eq 0 then trailer = {ad3_trailer}

  trailer = fitsHeaderToAd3Trailer(hdr, trailer)

  if trailer.nbdim eq -3 then begin
    sw = 1
  endif else begin 
    sw = 0
  endelse

  return, writeAd3(ad3, float(im), trailer, data_xyz=sw, write_xyz=ax)
end
