function makeGaussian2d, fwhm

  a = [0.0, 1.0, fwhm/(2.0*sqrt(2.0*alog(2.0))), fwhm/(2.0*sqrt(2.0*alog(2.0))), 0.0, 0.0, 0.0]

  nx = fwhm*4.0+1.0
  ny = fwhm*4.0+1.0

  x = (findgen(nx)-(nx-1.0)/2.0) # replicate(1.0, ny)
  y = replicate(1.0, nx) # (findgen(ny) - (ny-1.0)/2.0)

  u = ((x-a[4])/a[2])^2 + ((y-a[5])/a[3])^2

  z = a[0] + a[1] * exp(-u/2)

  return, z

end
