pro maskrv, rvFile, monoFile, monolevel, direction

  if n_elements(direction) eq 0 then direction = 1

  if file_test(rvFile, /read) eq 0 then begin
    print, 'Unable to read ' + rvFile
    return
  endif

  if file_test(monoFile, /read) eq 0 then begin
    print, 'Unable to read ' + monoFile
    return
  endif

  print, 'Masking ' + rvFile + ' with ' + monoFile + ' to level ' + strtrim(monolevel, 2)

  rvd = readad2(rvFile, trailrv)
  monod = readad2(monoFile)

  if direction eq 1 then begin
    idx = where(monod lt monolevel)
  endif else begin
    idx = where(monod gt monolevel)
  endelse

  if idx[0] ne -1 then begin
    rvd[idx] = -3.1e+38
  endif

  toto = writead2(rvFile, rvd, trailrv)

end
