;function medianRegion, cube, region

;  sz = size(cube)

;  integrate = fltarr(sz[1], n_elements(region))

;  for i=0, n_elements(region)-1 do begin
;    integrate[*,i] = total(total(cube[*,region[i].x1:region[i].x2, region[i].y1:region[i].y2], 2), 2)
;    integrate[*,i] = integrate[*,i]/((abs(region[i].x2-region[i].x1)+1)*(abs(region[i].y2-region[i].y1)+1))
;  endfor

;  if(n_elements(region) ne 1) then begin
;    return, median(integrate, dimension=2)
;  endif else begin
;    return, integrate
;  endelse
;end



function medianRegion, cube, region, binsize=b
COMPILE_OPT IDL2
  sz = size(cube)

  if n_elements(b) eq 0 then b=10

  b = floor(b)
  if (b le 2) then b=2

  if n_elements(region) ne 0 then begin
    sizex = fltarr(n_elements(region))
    sizey = fltarr(n_elements(region))
    pix = fltarr(n_elements(region))

    for i=0, n_elements(region)-1 do begin
      sizex[i] = region[i].x2-region[i].x1
      sizex[i] = sizex[i] - (sizex[i] mod b)

      sizey[i] = region[i].y2-region[i].y1
      sizey[i] = sizey[i] - (sizey[i] mod b)

      pix[i] = sizex[i]*sizey[i]
    endfor

    smallCube = fltarr(sz[1], total(pix)/(b*b))
    if (size(smallCube))[0] eq 1 then smallCube = reform(smallCube, sz[1], total(pix)/(b*b))

    pos = 0
    for i=0, n_elements(region)-1 do begin
      smallCube[*,pos/(b*b):(pos+pix[i])/(b*b)-1] = reform(rebin(cube[*,region[i].x1:region[i].x1+sizex[i]-1, region[i].y1:region[i].y1+sizey[i]-1], sz[1], sizex[i]/b, sizey[i]/b), sz[1], pix[i]/(b*b))
      pos = pos + pix[i]
    endfor

  endif else begin
    if sz[0] eq 3 then begin
      smallCube = reform(rebin(cube[*,0:sz[2]-(sz[2] mod b)-1, 0:sz[3]-(sz[3] mod b)-1], [sz[1], floor(sz[2]/b), floor(sz[3]/b)]), sz[1], (sz[2]/b)*(sz[3]/b))
    endif else begin
      smallCube = rebin(cube[*,0:sz[2]-(sz[2] mod (b*b))-1], [sz[1], floor(sz[2]/(b*b))])
    endelse
  endelse

  sz = size(smallCube)

  for i=0, sz[2]-1 do begin
    smallCube[*,i] = smallCube[*,i]-min(smallCube[*,i])
  endfor

  return, median(smallCube, dimension=2)
end
