; OK... concernant channel, on considere que le premier channel est 0
; Attention! Dans les ada, le premier channel est 1!

function readAdaToLambda, ada, ch, zsize, prb, efficiency, nphotons, offsetx, offsety, silent=sil, continuum_map=continuum_map
COMPILE_OPT IDL2
ON_ERROR, 0

  if n_elements(sil) eq 0 then sil=0

  sz = size(prb)
  xsize = sz[1]
  ysize = sz[2]

  if (n_elements(ada) ne 1) and (n_elements(continuum_map) eq xsize*ysize) then begin
    print, 'Multiple ada processing in readAdaToLambda is not supported anymore because of continuum_map'
    return, 0
  endif

  if n_elements(continuum_map) eq xsize*ysize then begin
    im = readada(ada[0], xsize, ysize, efficiency, nphotons, silent=sil)

    im -= continuum_map/efficiency[0]

    ; Test: Est-ce que ca revient au meme
    ; de shifter l'interferogramme et la phase parabolique avant de
    ; transformer en lambda plutot que de
    ; faire la translation dans l'espace lambda?
    im = interpolate(im, findgen(xsize)-offsetx, findgen(ysize)-offsety, /grid) 
 
;    temp = fltarr(zsize, xsize, ysize)

;    temp[ch, *, *] = im

    prb_temp = interpolate(prb, findgen(xsize)-offsetx, findgen(ysize)-offsety, /grid)

    temp = createLambdaSingleChannel(im, ch, zsize, prb_temp)
;    temp = createlambda(temp, prb_temp)

;    for i=0, zsize-1 do begin
;      temp[i,*,*] = interpolate(temp[i,*,*], findgen(xsize)+offsetx, findgen(ysize)+offsety, /grid)
;    endfor  

    return, temp
  endif

;  if n_elements(continuum_map) ne xsize*size then continuum_map = fltarr(xsize, ysize)

  if n_elements(efficiency) eq 0 then efficiency=1.0
  if n_elements(efficiency) ne n_elements(ada) then begin
    if sil eq 0 then begin
      print, 'Warning! n_elements(efficiency) ne n_elements(ada) (' + strtrim(n_elements(efficiency),2) + ', ' + strtrim(n_elements(ada),2) + ')'
    endif
    efficiency = replicate(efficiency[0], n_elements(ada))
  endif

  temp = fltarr(zsize, xsize, ysize)
;  lambda = fltarr(zsize, xsize, ysize)
  nphotons = 0
  ; Pour eviter de tombre dans les negatifs quand on soustrait la phase...
  channel = ch + zsize

  if n_elements(offsetx) ne 0 then begin
    offsetx = float(offsetx)
    if offsetx lt 0 then begin
      offx = ceil(offsetx)
      offsetx = abs(offsetx)
      if floor(offsetx) eq ceil(offsetx) then begin
        propxneg = 0
        propx = 1
      endif else begin
        propxneg = offsetx-floor(offsetx)
        propx = ceil(offsetx)-offsetx
      endelse
      propxpos = 0
    endif else begin
      offx = floor(offsetx)
      if floor(offsetx) eq ceil(offsetx) then begin
        propxpos = 0
        propx = 1
      endif else begin
        propxpos = offsetx-floor(offsetx)
        propx = ceil(offsetx)-offsetx
      endelse
      propxneg = 0
    endelse
  endif else begin
    propx = 1
    propxneg = 0
    propxpos = 0
    offx = 0
  endelse

  if n_elements(offsety) ne 0 then begin
    offsety = float(offsety)
    if offsety lt 0 then begin
      offy = ceil(offsety)
      offsety = abs(offsety)
      if floor(offsety) eq ceil(offsety) then begin
        propyneg = 0
        propy = 1
      endif else begin
        propyneg = offsety-floor(offsety)
        propy = ceil(offsety)-offsety
      endelse
      propypos = 0
    endif else begin
      offy = floor(offsety)
      if floor(offsety) eq ceil(offsety) then begin
        propypos = 0
        propy = 1
      endif else begin
        propypos = offsety-floor(offsety)
        propy = ceil(offsety)-offsety
      endelse
      propyneg = 0
    endelse
  endif else begin
    propy = 1
    propyneg = 0
    propypos = 0
    offy = 0
  endelse

  ; La matrice 3x3 est definie ainsi:
  ; (-1,-1), (0,-1), ( 1,-1)
  ; (-1, 0), (0, 0), ( 1, 0)
  ; (-1, 1), (0, 1), ( 1, 1)
  xymatrix = [[propxneg*propyneg, propx*propyneg, propxpos*propyneg], [propxneg*propy, propx*propy, propxpos*propy], [propxneg*propypos, propx*propypos, propxpos*propypos]]

;  print, xymatrix, offx, offy

  if n_elements(channel) eq 1 then channel = replicate(channel, n_elements(ada))

  channel = float(channel)

  for i=0, n_elements(ada)-1 do begin
  
    info = file_info(ada[i])

    if (info.exists eq 0) or (info.read eq 0) then continue
  
    if (info.size eq 0) then continue

    openr, unit, ada[i], /get_lun, /swap_if_big_endian

    np = info.size/4
    nphotons = nphotons + np

    data = uintarr(2, np)

    point_lun, unit, 0

    readu, unit, data

    free_lun, unit

    data[1,*] = data[1,*] < (xsize-1)
    data[0,*] = data[0,*] < (ysize-1)
    data = data > 0

    for j=0, np-1 do begin
      xpos = data[1,j]
      ypos = data[0,j]
      zpos = float(channel[i])-(prb[xpos, ypos] mod zsize)

; Ancienne methode
      if ceil(zpos) eq floor(zpos) then begin
        zlow = 1
        zhigh = 0
      endif else begin
        zhigh = zpos-floor(zpos)  ; Proportion du photon canal bas
        zlow = ceil(zpos)-zpos  ; Proportion du photon canal haut
      endelse

      zmatrixhigh = xymatrix*zhigh/efficiency[i]
      zmatrixlow = xymatrix*zlow/efficiency[i]

      xposlow = ((xpos+offx-1)>0)<(xsize-1)
      xposhigh = ((xpos+offx+1)>0)<(xsize-1)
      yposlow = ((ypos+offy-1)>0)<(ysize-1)
      yposhigh = ((ypos+offy+1)>0)<(ysize-1)

      if ((xposhigh-xposlow) eq 2) and ((yposhigh-yposlow) eq 2) then begin
        zpos = floor(zpos)
        temp[zpos mod zsize, xposlow:xposhigh, yposlow:yposhigh] = temp[zpos mod zsize, xposlow:xposhigh, yposlow:yposhigh] + zmatrixlow 
        temp[(zpos+1) mod zsize, xposlow:xposhigh, yposlow:yposhigh] = temp[(zpos+1) mod zsize, xposlow:xposhigh, yposlow:yposhigh] + zmatrixhigh
      endif

    endfor

;    lambda = lambda + createlambda(temp, prb)

  endfor

  return, temp

end



; Nouvelle methode
;      pixel_temp = fltarr(zsize)
;      pixel_temp[channel[i] mod zsize] = 1
;      pixel_temp = (interpolate([pixel_temp, pixel_temp, pixel_temp], findgen(zsize*3)+(prb[i,j] mod zsize)))[zsize:zsize*2-1]

;      pixel_temp = [[pixel_temp], [pixel_temp], [pixel_temp]]
;      pixel_temp = [[[pixel_temp]], [[pixel_temp]], [[pixel_temp]]]

;      for j=0, zsize-1 do begin
;        pixel_temp[j,*,*] = pixel_temp * xymatrix    
;      endfor

;      xposlow = ((xpos+offx-1)>0)<(xsize-1)
;      xposhigh = ((xpos+offx+1)>0)<(xsize-1)
;      yposlow = ((ypos+offy-1)>0)<(ysize-1)
;      yposhigh = ((ypos+offy+1)>0)<(ysize-1)

;      if ((xposhigh-xposlow) eq 2) and ((yposhigh-yposlow) eq 2) then begin
;        temp[*, xposlow:xposhigh, yposlow:yposhigh] = temp[*, xposlow:xposhigh, yposlow:yposhigh] + pixel_temp
;      endif
