function readAdTrailer, filename
COMPILE_OPT IDL2
  realfilename = filename

  info = file_info(realfilename)

  testgz = strsplit(realfilename, '.', /extract)
  testgz = testgz[n_elements(testgz)-1]

  if (info.exists eq 0) or (info.read eq 0) or (testgz eq 'gz') then begin
    ; On regarde si plutot le fichier est .ad?.gz...
    if (testgz ne 'gz') then begin
      realfilename = filename + '.gz'
      info = file_info(realfilename)
    endif else begin
      realfilename = filename
    endelse

    if (info.exists eq 0) or (info.read eq 0) then return, -1
    if (!version.os_family ne 'unix') then return, -1

    testgz = 'gz'

    spawn, 'gzip -cd ' + realfilename, unit=unit
    spawn, 'gzip -l ' + realfilename, output
    output = strsplit(output[1], ' ', /extract)
    size = ulong64(output[1])
    toto = fltarr((size-256)/4, /nozero)
    readu, unit, toto
    toto = 0
  endif else begin
    openr, unit, realfilename, /get_lun
    if (n_elements(unit) eq 0) then begin
      print, 'Unable to open ' + realfilename + ' for reading'
      return, -1
    endif
    size = info.size
    point_lun, unit, size-256
  endelse

  trailer = {ad3_trailer}

  readu, unit, trailer
  swap_endian_inplace, trailer, /swap_if_big_endian


  if trailer.nbdim ne 2 then goto, fin

  if testgz eq 'gz' then begin
    free_lun, unit
    spawn, 'gzip -cd ' + realfilename, unit=unit
    toto = fltarr((size-256)/4, /nozero)
    readu, unit, toto
    toto = 0
  endif else begin
    point_lun, unit, info.size-256
  endelse

  trailer = {ad2_trailer}
  readu, unit, trailer

  swap_endian_inplace, trailer, /swap_if_big_endian

fin:
  free_lun, unit

  if testgz eq 'gz' then begin
    trailer.was_compressed = 1
  endif

  return, trailer
end
