function readAdz, file
COMPILE_OPT IDL2
  if n_params() eq 0 then begin
    print, 'Syntax: readAdz(file)'
    print, 'file - File to read (.adz)'
    return, -1
  endif

  readcol, file, ciel1, ciel2, ciel3, ciel4, /silent

  gvalues = where(ciel1 eq -999)

  if gvalues[0] ne -1 then begin
    remove, gvalues, ciel1
    remove, gvalues, ciel2
    remove, gvalues, ciel3
    remove, gvalues, ciel4
  endif

  cielz = fltarr(4, n_elements(ciel1))

  cielz = reform(cielz, 4, n_elements(ciel1)) ; S'assurer qu'on a 2 dimensions
                                              ; meme si n_elements(ciel1) eq 1

  for i=0, n_elements(ciel1)-1 do begin
    cielz[0,i] = ciel1[i]  ; x1
    cielz[1,i] = ciel2[i]  ; y1 
    cielz[2,i] = ciel3[i]  ; x2
    cielz[3,i] = ciel4[i]  ; y2
  endfor

  return, cielz
end
