function spectralSmooth, cube, method

  if n_elements(method) eq 0 then method = 1
  if method gt 2 then method = 2

  case method of
    1: smooth = [0.25, 0.5, 0.25] ; Hanning
    2: smooth = [0.0625, 0.2916, 0.7349, 1, 0.7349, 0.2916, 0.0625] ; Gaussian fhwm 3
  endcase

  sz = size(cube)

  for x=0, sz[2]-1 do begin
    for y=0, sz[3]-1 do begin
      cube[*, x, y] = convol(cube[*, x, y], smooth, /edge_wrap)
    endfor
  endfor

  cube = cube / total(smooth)

  return, cube

end
