function substractSky, cube, validCalibTemp, ciel_cube=ciel_cube, spectrum=iciel, factors=fac, region=reg, skyreg=sky, ohmap=ohmap, map=ohreg, plot=p, degree=degree
COMPILE_OPT IDL2
ON_ERROR, 0

  if n_elements(fac) eq 0 then fac=1
  if n_elements(p) eq 0 then p=0
  if n_elements(degree) eq 0 then degree=4
  if n_elements(ciel_cube) ne 0 then ciel_from_cube=1 else ciel_from_cube=0

;  if degree ne 4 then degree=2

  if n_elements(ciel_cube) eq 0 then ciel_cube = cube

  sz = size(cube)

  sn = fltarr(sz[2], sz[3])
  for x=0, sz[2]-1 do begin
    for y=0, sz[3]-1 do begin
      sn[x,y] = computeSignalNoiseValue(cube[*,x,y])
    endfor
  endfor

  med = median(sn)
  print, 'Median SN is ' + strtrim(med,2)

  ; On veut un SN sur le ciel de 40...
  res = (ceil((40.0/med))>2.0)<50.0

  print, 'Resolution is ' + strtrim(res,2)

  ohreg = fltarr(sz[2], sz[3])

  if n_elements(reg) ne 0 then begin
    temp = skyZoneToMask(reg, sz[2], sz[3])
  endif else begin
    temp = bytarr(sz[2], sz[3])
    temp[*,*] = 1
  endelse

  temp2 = bytarr(sz[2], sz[3])
  temp2[validCalibTemp] = 1

  validCalib = where(temp2 and temp)

  if n_elements(sky) eq 0 then begin
    if (ciel_from_cube eq 0) then begin
      ; On s'arrange pour ne pas avoir plus
      ; de la moitie du cube qui est considere comme du ciel
      fraction = 1.0
      cf = 0.85
      all_fraction = [fraction]
      all_cf = [cf]
      ohreg[validCalib] = (findOh(ciel_cube, res, validCalib=validCalib, correlation=cf))[validCalib]
      test = float(n_elements(where(ohreg[validCalib] ge 1)))
      fraction = test / float(n_elements(validCalib))

      if fraction lt 0.5 then mfactor = 1.0/1.01 else mfactor = 1.01

      iters = 0

      while ((fraction ge 0.5) and mfactor ge 1.0) or ((fraction le 0.5) and mfactor le 1.0) do begin
        ohreg[validCalib] = (findOh(ciel_cube, res, validCalib=validCalib, correlation=cf))[validCalib]
        test = float(n_elements(where(ohreg[validCalib] ge 1)))
        all_cf = [all_cf, cf]
        cf *= mfactor
        fraction = test / float(n_elements(validCalib))
        all_fraction = [all_fraction, fraction]

        print, 'Fraction and CF: ', fraction, cf
        iters = iters + 1
        if iters gt 20 then break
        if cf gt 0.95 then break
      endwhile
   
      min = min((0.5-all_fraction)^2, idx)
      cf = all_cf[idx]
      ohreg[validCalib] = (findOh(ciel_cube, res, validCalib=validCalib, correlation=cf))[validCalib]
      test = float(n_elements(where(ohreg[validCalib] ge 1)))
      fraction = test / float(n_elements(validCalib))

      print, 'Used correlation factor of ' + strtrim(cf,2)
      print, 'Fraction of sky: ' + strtrim(fraction,2)
    endif else begin
      ohreg[validCalib] = 1
    endelse
  endif else begin
    temp = skyZoneToMask(sky, sz[2], sz[3])
    ohreg[validCalib] = 1
    ohreg = ohreg and temp
  endelse

  cubeNoContinum = ciel_cube ; fltarr(sz[1], sz[2], sz[3], /nozero)

  for x=0, sz[2]-1 do begin
    for y=0, sz[3]-1 do begin
      cubeNoContinum[*,x,y] -= min(cubeNoContinum[*,x,y])
    endfor
  endfor

  cubeFinal = cube

  if p eq 1 then begin
    window, 0, xsize=sz[2], ysize=sz[3]
    loadct, 0
    tvscl, ohreg
  endif

  x = findgen(sz[2]) # replicate(1.0, sz[3])
  y = replicate(1.0, sz[2]) # findgen(sz[3])

  for i=0, n_elements(fac)-1 do begin
    print, 'Going with factor ' + strtrim(fac[i])
    if keyword_set(ohmap) then begin ; and (float(n_elements(where(ohreg eq 1)))/float(n_elements(validCalid)) gt 0.25) then begin

      idx = where(ohreg ne 0.0)
      irr = fltarr(3, n_elements(idx))
      irr[0,*] = idx mod sz[2]
      irr[1,*] = floor(idx/sz[2])

      cubeciel = fltarr(sz[1], sz[2], sz[3])
      cubeTemp = reform(cubeNoContinum, sz[1], sz[2]*sz[3])

      print, 'Degree is', degree

      for j=0, sz[1]-1 do begin
        irr[2,*] = cubetemp[j, idx]
;        irrtemp = sfit(irr, degree, /irregular, max_degree=degree, kx=kx)
        irrtemp = sfit(irr, degree, /irregular, kx=kx)
;        irrtemp = sfit(irr, 1, /irregular, kx=kx)
        cubeciel[j,*,*] = surfaceFromKx(kx, sz[2], sz[3])
      endfor

;      cubeciel -= min(medianRegion(cubeciel[*, idx]))

      cubeciel = cubeciel * fac[i]

      if i eq 0 then begin
        iciel = cubeciel
      endif else begin
        iciel = iciel + cubeciel
      endelse

      cubeNoContinum = cubeNoContinum - cubeciel
      cubeFinal = cubeFinal - cubeciel

    endif else begin

      cuber = reform(cubeFinal, [sz[1], sz[2]*sz[3]])
      idx = where(ohreg ne 0.0)
;      idx = validCalib

      icieltemp = medianRegion(cuber[*, idx]);, dimension=2)
      icieltemp = icieltemp * fac[i]
      if i eq 0 then begin
        iciel=icieltemp
      endif else begin
         iciel = iciel + icieltemp
      endelse
      for x=0, sz[2]-1 do begin
        for y=0, sz[3]-1 do begin
          cubeFinal[*,x,y] = cubeFinal[*,x,y] - icieltemp
        endfor
      endfor

    endelse
  endfor


  return, cubeFinal

end
